from functools import wraps
from flask import current_app, request, jsonify
from flaschengeist import logger

def login_required(**kwargs):
    from .controller.accessTokenController import AccessTokenController
    accessController = AccessTokenController()
    roles = None
    if "roles" in kwargs:
        roles = kwargs["roles"]

    def real_decorator(func):
        @wraps(func)
        def wrapper(*args, **kwargs):
            token = request.headers.get('Token')
            logger.debug("token is {{ {} }}".format(token))
            accToken = accessController.validateAccessToken(token, roles)
            logger.debug("accToken is {{ {} }}".format(accToken))
            kwargs['accToken'] = accToken
            if accToken:
                logger.debug("token {{ {} }} is valid".format(token))
                return func(*args, **kwargs)
            else:
                logger.warning("token {{ {} }} is not valid".format(token))
                return jsonify({"error": "error",
                                "message": "permission denied"}), 401
        return wrapper
    return real_decorator
